.INCLUDE "m16def.inc"

#define DS18B20	; DS18S20  DS1820   

.EQU dig0=0x40
.EQU dig1=0x79
.EQU dig2=0x24
.EQU dig3=0x30
.EQU dig4=0x19
.EQU dig5=0x12
.EQU dig6=0x02
.EQU dig7=0x78
.EQU dig8=0x00
.EQU dig9=0x10

.DEF mlgod=r0      ;   
.DEF stgod=r1      ;   
.DEF mesyac=r2     ;  
.DEF den=r3        ;  
.DEF chas=r4       ;  
.DEF minuta=r5     ;  
.DEF sekunda=r6    ;  
.DEF dinmode=r15   ;  
.DEF stek=r8       ; 
.DEF zimleto=r7    ;  /(0- ., 1-, 2-)
.DEF godzl=r31     ;  28-  
.DEF cikldata=r9   ;  ..  
.DEF sle=r10       ;  .
.DEF konvert=r11   ;   
.DEF temperznak=r13
.DEF temperznach=r12
.DEF indpreobrt=r14     
.DEF temp=r16      ;  
.DEF rez_delim=r17 ;   (  )
.DEF delitel=r18   ; (  ) 
.DEF ostatok=r19   ; (  )
.DEF sch=r20       
.DEF hod=r22       ;  (      )
.DEF dvoet=r21     ;   
.DEF dney=r23      ;         
.DEF naj=r25       ;    

;*******************************************************


.CSEG

           jmp RESET
		   rjmp E_INT0
		   nop
		   nop
		   nop
		   nop
		   nop
		   rcall Timer
		   reti
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop

;*******************************************************

RESET:     

           ldi temp,high(RAMEND)  ; 
		   out SPH,temp
		   ldi temp,low(RAMEND)
		   out SPL,temp
;     
           
		   ldi temp,0x01
		   mov den,temp
		   mov mesyac,temp
		   ldi temp,0x14
		   mov stgod,temp
		   clr temp
		   mov mlgod,temp
		   mov chas,temp
		   mov minuta,temp
		   mov sekunda,temp
		   clr zimleto
		   clr r31
		   clr r30
		   clr hod

;*******************************************************

           ldi temp,0xFF        
           out DDRA,temp          ; 
		   ldi temp,0x59
		   mov stek,temp
		   ldi temp,0x3F
		   out DDRC,temp
		   out PORTC,temp
		   clr temp
		   out PORTA,temp
		   ldi temp,0b10110000
		   out DDRD,temp
		   ldi temp,0b10110011
		   out PORTD,temp

		   clr temp              ; 
		   out SFIOR,temp        ;

;*******************************************************
;    
; 
Hod10:     rcall TIM_Asyn;10ms

;*******************************************************
Hod1:     
           ldi temp,0xFF        ; 
		   mov dinmode,temp
		   out DDRA,temp
		   ldi temp,0x3F
		   out DDRC,temp
		   out PORTC,temp
		   ldi temp,0x5F
		   out SPL,temp
		   clr temp
		   out PORTA,temp
		   ldi temp,0b10110000
		   out DDRD,temp
		   ldi temp,0b10110011
		   out PORTD,temp
           clr temp              ; 
		   out SFIOR,temp        ;
           clr naj                       ;  ()
           ldi temp,0b00000010
		   out MCUCR,temp
		   ldi temp,0b01000000
		   out GICR,temp
		   clr hod
		   sei
Hod_svet1: 
  
           sbi PORTD,7  
           mov rez_delim,den   ;1
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cpi r30,0
		   breq HS1
		   cbi PORTD,5
		   nop
HS1:	   rcall ZAD_1_25m
		   sbi PORTD,5

		   sbis PIND,0
		   rcall NAJ0
		   sbis PIND,1
		   rcall NAJ1
		   
		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTD,4
		   nop
		   rcall ZAD_1_25m
		   sbi PORTD,4        ;***
		   
		   mov rez_delim,mesyac  ;2
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cpi r30,0
		   breq HS12
		   cbi PORTC,5
		   nop
HS12:	   rcall ZAD_1_25m
		   sbi PORTC,5

		   

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,4
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,4         ;***


		   sbis PIND,0
           rcall MM1
           sbis PIND,1
		   rcall MM1
		   clr naj 

MM1:	   mov rez_delim,stgod  ;3
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,3
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,3

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,2
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,2          ;***

		  

		   mov rez_delim,mlgod  ;4
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,1
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,1

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,0
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,0
		   tst dinmode
           brne A1
           ldi temp,0x05
		   mov dinmode,temp
		   rjmp Hod_svet0 
A1:		   rjmp Hod_svet1
		   ret  


;*******************************************************
Hod0:      
           ldi temp,0xFF        ; 
           out DDRA,temp
		   out DDRC,temp
		   out PORTC,temp
		   ldi temp,0x5F
		   out SPL,temp
		   clr temp
		   out PORTA,temp
		   ldi temp,0b10110000
		   out DDRD,temp
		   ldi temp,0b10110011
		   out PORTD,temp
           clr temp              ; 
		   out SFIOR,temp        ;
           clr naj
           ldi temp,0b00000010
		   out MCUCR,temp
		   ldi temp,0b01000000
		   out GICR,temp
		   sei
		   cbi PORTD,7
Hod_svet0: 
          
           sbis PORTD,7
		   rcall DVT_C
		   sbic PORTD,7
		   rcall DVT_S
		   clr temp  
           mov rez_delim,den   ;1
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cpi r30,0
		   breq HS2
		   cbi PORTD,5
		   nop
HS2:	   rcall ZAD_1_25m
		   sbi PORTD,5

		   sbis PIND,0
		   rcall NAJ2
		   sbis PIND,1
		   rcall NAJ3
		   
		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTD,4
		   nop
		   rcall ZAD_1_25m
		   sbi PORTD,4        ;***
		   
		   mov rez_delim,mesyac  ;2
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
           cpi r30,0
		   breq HS21
		   nop
		   cbi PORTC,5
		   nop
HS21:	   rcall ZAD_1_25m
		   sbi PORTC,5

		  

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,4
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,4         ;***

		   
		   sbis PIND,0
           rcall MM2
           sbis PIND,1
		   rcall MM2
		   clr naj   
		   
MM2:       mov rez_delim,chas  ;3
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   cpi r30,0
		   breq HS22
		   nop
		   cbi PORTC,3
		   nop
HS22:	   rcall ZAD_1_25m
		   sbi PORTC,3

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,2
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,2          ;***

		   

		   mov rez_delim,minuta  ;4
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,1
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,1

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,0
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,0
		   tst dinmode
           brne A2
           ldi temp,0x05
		   mov dinmode,temp
		   rjmp Hod_svet3 
A2:		   rjmp Hod_svet0
		   ret

;*******************************************************
;*******************************************************
Hod3:      
           ldi temp,0xFF        ; 
           out DDRA,temp
		   ldi temp,0x3F
		   out DDRC,temp
		   out PORTC,temp
		   ldi temp,0x5F
		   out SPL,temp
		   clr temp
		   out PORTA,temp
		   ldi temp,0b10111000
		   out DDRD,temp
		   ldi temp,0b10111011
		   out PORTD,temp
           clr temp              ; 
		   out SFIOR,temp        ;
           clr naj                       ;  ()
           ldi temp,0b00000010
		   out MCUCR,temp
		   ldi temp,0b01000000
		   out GICR,temp
		   sei
		   ldi temp,0x80
		   mov temperznach,temp
		   sbi PORTD,7
           clr konvert
		   clr temperznak           


Hod_svet3: 
           
           clr temp  

;******************************************************
;   
           tst konvert
           breq ZAPR
		   rjmp POSL_ZAPR1
ZAPR:      tst indpreobrt
           breq KONVT
		   rjmp SCHIT_ZN           
		   
		     
;* * * *      * * * *
KONVT:     
           mov rez_delim,den   ;1
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cpi r30,0
		   breq HS111
		   cbi PORTD,5
		   nop
HS111:	   
           cbi PORTD,3
		   rcall ZAD_480mks
		   sbi PORTD,3
		   rcall ZAD_60mks
		   cbi DDRD,3
		   nop
		   sbic PIND,3
		   rjmp BEZ_T
		   rcall ZAD_20mks
		   sbi DDRD,3
		   sbi PORTD,7
		   rcall ZAD_20mks
		   rcall ZAD_20mks
		   rcall ZAD_20mks
		   rcall ZAD_20mks
		   rcall ZAD_320mks

;* * * * * * * * * * * * * * * * * * * * * * * * * * * *

;  (=11001100)
;*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*
           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   nop
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   nop
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

		   cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

		   cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***
;*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*

;  (t=0.75)(01000100)
;*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*           
		   cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   nop
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

		   
		   cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   nop
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

                      
           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   nop
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***


           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   nop
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***


           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   nop
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***


           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   nop
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***
;*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*
   
           inc konvert   ;  
		   inc konvert   ; 2   
		                 ; 
           inc indpreobrt; "" -
		                 ; 
           rcall ZAD_338mks
		   sbi PORTD,5

           rjmp POSL_ZAPR

SCHIT_ZN:
;* * * *      * * * *
           mov rez_delim,den   ;1
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cpi r30,0
		   breq HS112
		   cbi PORTD,5
		   nop
HS112:	   		   
		   cbi PORTD,3
		   rcall ZAD_480mks
		   sbi PORTD,3
		   rcall ZAD_60mks
		   cbi DDRD,3
		   nop
		   sbic PIND,3
		   rjmp BEZ_T
		   rcall ZAD_20mks
		   sbi DDRD,3 
		   rcall ZAD_20mks
		   rcall ZAD_20mks
		   rcall ZAD_20mks
		   rcall ZAD_20mks
		   rcall ZAD_320mks

           
		   ;  (=11001100)
;*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*
           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

		   cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            ;***

		   cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

               ;" "(BE=10111110)
;*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            
		                  ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***

           cbi PORTD,3    ;***"0"   
		   rcall ZAD_60mks
		   nop
		   sbi PORTD,3
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop            
		                   ;***

           cbi PORTD,3    ;***"1"
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
           sbi PORTD,3
		   rcall ZAD_12_5mks
		   rcall ZAD_45mks
                          ;***
           
		   sbi PORTD,5

           
;*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*(*
	
		;   9()   
#ifdef DS18B20
        ;    
		cbi PORTD,3  ; 0  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ;ror temperznach
           sbi DDRD,3
		   nop

		   cbi PORTD,3  ; 0  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ;ror temperznach
           sbi DDRD,3
		   nop

		   cbi PORTD,3  ; 0  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ;ror temperznach
           sbi DDRD,3
		   nop


#endif		
		   cbi PORTD,3  ; 0  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ror temperznach
           sbi DDRD,3
		   nop
                         ;*****  
						 
						 
		   cbi PORTD,3  ; 1  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ror temperznach
           sbi DDRD,3
		   nop
                         ;*****	
						 
		   cbi PORTD,3  ; 2  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ror temperznach
           sbi DDRD,3
		   nop
                         ;*****	
						 
		   cbi PORTD,3  ; 3  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ror temperznach
           sbi DDRD,3
		   nop
                         ;*****	
						 
		   cbi PORTD,3  ; 4  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ror temperznach
           sbi DDRD,3
		   nop
                         ;*****	
						 
		   cbi PORTD,3  ; 5  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ror temperznach
           sbi DDRD,3
		   nop
                         ;*****	
						 
		   cbi PORTD,3  ; 6  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ror temperznach
           sbi DDRD,3
		   nop
                         ;*****	
						 
		   cbi PORTD,3  ; 7  temperznach
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   sec
		   sbis PIND,3
		   clc
		   rcall ZAD_45mks
		   ror temperznach
           sbi DDRD,3
		   nop
                         ;*****	
						 
						 
						 
		   cbi PORTD,3  ; 0  temperznak
		   nop
		   nop
		   nop
		   nop
		   nop
		   nop
		   ;sbi PORTD,3
           cbi DDRD,3
		   nop
		   nop
		   rcall ZAD_10mks
           sbic PIND,3
		   rcall ABCT
		   sbis PIND,3
		   clr temperznak
		   rcall ZAD_45mks
		   nop
           sbi DDRD,3
		   nop
                         ;*****				 			 			 			 			 			 			 			    
           
           clr indpreobrt 
		   sbi PORTD,5          


POSL_ZAPR:
           
		    mov temp,temperznach
		    cpi temp,0x80
		    brne S_T    ;breq BEZ_T
		    rjmp BEZ_T


		   


;          * * * * * * * * *

POSL_ZAPR1:mov rez_delim,den   ;1
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cpi r30,0
		   breq HS113
		   cbi PORTD,5
		   nop
HS113:     rcall ZAD_1_25m
           sbi PORTD,5
          
S_T:      
           mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTD,4
		   nop
		   rcall ZAD_1_25m
		   sbi PORTD,4

           mov rez_delim,mesyac  ;2
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
           cpi r30,0
		   breq HS311
		   nop
		   cbi PORTC,5
		   nop
HS311:	   rcall ZAD_1_25m
		   sbi PORTC,5

	
		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,4
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,4         ;***

           mov temp,temperznach  ;2
		   tst temperznak
		   breq S_S_S1
		   dec temp
           com temp
S_S_S1:	   lsr temp
           mov rez_delim,temp  
		   rcall del_na_10

           ldi temp,0b00111111
		   out PORTA,temp
		   tst temperznak
		   breq SSS
		   tst rez_delim
           breq SSS
		   

		   cbi PORTC,3
SSS:	   nop
           rcall ZAD_1_25m
		   sbi PORTC,3           ;***
		   
           sbis PIND,0
		   rcall NAJ4
		   sbis PIND,1
		   rcall NAJ5

		   tst rez_delim
		   brne S_S_S
		   tst ostatok
		   breq HS32
		   tst temperznak
		   breq HS32
		   ldi temp,0b00111111
		   out PORTA,temp
		   rjmp HS321 
           
S_S_S:	   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cpi r30,0
		   breq HS32
HS321:  
		   cbi PORTC,2
		   nop
HS32:	   rcall ZAD_1_25m
		   sbi PORTC,2

		   

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,1
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,1         ;***

	  	   sbis PIND,0
           rcall MM3
           sbis PIND,1
		   rcall MM3
		   clr naj 

MM3:
           ldi temp,0b00011100
		   out PORTA,temp
		   nop
		   cbi PORTC,0
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,0

		   tst dinmode
           brne A3
           ldi temp,0x05
		   mov dinmode,temp
		   rjmp Hod_svet1 

A3:		   rjmp Hod_svet3
		   ret  



;            * * * * * *
BEZ_T:     sbi DDRD,3
           ldi temp,0x80
		   mov temperznach,temp
           sbis PORTD,7
		   rcall DVT_C
		   sbic PORTD,7
		   rcall DVT_S
		   clr temp  
           mov rez_delim,den   ;1
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cpi r30,0
		   breq HS231
		   cbi PORTD,5
		   nop
HS231:	   rcall ZAD_1_25m
		   sbi PORTD,5

		   sbis PIND,0
		   rcall NAJ4
		   sbis PIND,1
		   rcall NAJ5
		   
		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTD,4
		   nop
		   rcall ZAD_1_25m
		   sbi PORTD,4        ;***
		   
		   mov rez_delim,mesyac  ;2
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
           cpi r30,0
		   breq HS213
		   nop
		   cbi PORTC,5
		   nop
HS213:	   rcall ZAD_1_25m
		   sbi PORTC,5

		  

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,4
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,4         ;***

		   
		   sbis PIND,0
           rcall MM222
           sbis PIND,1
		   rcall MM222
		   clr naj   
		   
MM222:     mov rez_delim,chas  ;3
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   cpi r30,0
		   breq HS221
		   nop
		   cbi PORTC,3
		   nop
HS221:	   rcall ZAD_1_25m
		   sbi PORTC,3

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,2
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,2          ;***

		   

		   mov rez_delim,minuta  ;4
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,1
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,1

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   nop
		   cbi PORTC,0
		   nop
		   rcall ZAD_1_25m
		   sbi PORTC,0
           
		   tst dinmode
           brne A4
           ldi temp,0x05
		   mov dinmode,temp
		   rjmp Hod_svet1 

A4:		   rjmp Hod_svet3
		   ret
;***************************************************


Hod4:
           ldi temp,0xFF        ; 
           out DDRA,temp
		   ldi temp,0x3F
		   out DDRC,temp
		   out PORTC,temp
		   ldi temp,0x5F
		   out SPL,temp
		   clr temp
		   out PORTA,temp
		   ldi temp,0b10111000
		   out DDRD,temp
		   ldi temp,0b10111011
		   out PORTD,temp
           clr temp              ; 
		   out SFIOR,temp        ;
           clr naj                       ;  ()
           ldi temp,0b00000010
		   out MCUCR,temp
		   ldi temp,0b01000000
		   out GICR,temp
		   sei
		   ldi temp,0xFF
		   mov temperznach,temp
		   sbi PORTD,7
           clr konvert
		   clr temperznak        

Hod_svet4:
  
           ldi temp,0x05
		   mov dinmode,temp
		   rjmp Hod_svet1
		   ret





		   
		      
;*******************************************************
Hod2:      ldi temp,0b01110010
           out MCUCR,temp
		   clr temp
		   out DDRA,temp
		   out DDRD,temp
		   out DDRC,temp
		   out PORTA,temp
		   out PORTD,temp
		   out PORTC,temp
		   inc sle
HD:		   out SPL,stek
           sei
		   clr sle
		   inc sle
		   sleep 
		   ret
;*******************************************************
;    1

TIM_Asyn:  clr temp
           out TIMSK,temp
		   out TCNT2,temp
		   ldi temp,0x08
		   out ASSR,temp
		   ldi temp,0x05
		   out TCCR2,temp
		   ldi temp,0b01000000
		   nop
		   nop
		   nop
		   out TIMSK,temp
		   reti
;********************************************************
E_INT0:    sei
           clr sle
           sbis PIND,2
		   rjmp Hod2
		   ldi temp,0b00000010
           out MCUCR,temp
           cpi hod,0
		   brne Hod111
    	   rjmp Hod1  ; .()
Hod111:    cpi hod,1
           brne Hod112
           rjmp Hod0  ; .()
Hod112:    cpi hod,2
           brne Hod113
           rjmp Hod3  ; .()
Hod113:    rjmp Hod4  ; .(.)		   	 
           ret
;********************************************************
;********************************************************
;  1,25ms

ZAD_1_25m:       	 ;(2.3ms)
           ldi r28,0xF0;ldi r28,0xFF!!!
		   ldi r29,0x0C;ldi r29,0x10!!!
M1:        dec r28
           brne M1
		   dec r29
		   brne M1
		   ret
;*********************************************************
;   10
del_na_10: 
           ldi delitel,0x0A
           sub ostatok,ostatok
		   ldi sch,9
d8u_1:     rol rez_delim
           dec sch
		   brne d8u_2
		   ret
d8u_2:     rol ostatok
           sub ostatok,delitel
		   brcc d8u_3
		   add ostatok,delitel
		   clc

		   rjmp d8u_1
d8u_3:     sec
           
		   rjmp d8u_1
		   ret
;*********************************************************
;   1 .
DVT_C:                      
           inc dvoet
		   cpi dvoet,0x32
		   breq DV1
           ret
DV1:       clr dvoet
           sbi PORTD,7
		   ret
;*********************************************************
;   1 .
DVT_S: 
           inc dvoet
		   cpi dvoet,0x32
		   breq DV2
           ret
DV2:       clr dvoet
           cbi PORTD,7
		   ret
;*********************************************************
;  ()
Timer:     
           
		   inc sekunda
		   sei

		   rcall TIM
		   sbis PIND,2
		   rjmp HD
           tst sle
           breq T2
		   rjmp E_INT0
T2:
		   tst konvert
		   breq TT
		   dec konvert
TT:
           mov temp,dinmode
		   cpi temp,0xFF
		   breq TTT
		   dec dinmode
TTT:       reti


TIM:
		   
           mov temp,sekunda
		   cpi temp,0x3C
		   brne T1 
		   clr sekunda
		   inc minuta
		   mov temp,minuta
		   cpi temp,0x3C
		   brne T1
		   clr minuta
		   inc chas
		   rcall ZLVREMYA
           mov temp,chas
		   cpi temp,0x18
		   brne T1
		   clr chas
		   inc den
		   rcall DEN1
		   cp den,dney
		   brne T1
		   clr den
		   inc den
           inc mesyac
           mov temp,mesyac
		   cpi temp,13
		   brne T1
		   clr mesyac
		   inc mesyac
		   inc mlgod
		   inc godzl
		   cpi godzl,28
           brne TT1
		   clr godzl
TT1:       mov temp,mlgod
		   cpi temp,100
		   brne T1
		   clr mlgod
		   inc stgod
T1:        ser temp
           reti	   	              
;***********************************************************
DEN1:      
           mov temp,mesyac 
           cpi temp,1
		   brne D1
		   ldi dney,32
D1:        cpi temp,2
           brne D2
		   rcall FEVR
		   mov dney,r24
D2:        cpi temp,3
           brne D3
		   ldi dney,32
D3:        cpi temp,4
           brne D4
		   ldi dney,31
D4:        cpi temp,5
           brne D5
		   ldi dney,32
D5:        cpi temp,6
           brne D6
		   ldi dney,31
D6:        cpi temp,7
           brne D7
		   ldi dney,32
D7:        cpi temp,8
           brne D8
		   ldi dney,32
D8:        cpi temp,9
           brne D9
		   ldi dney,31
D9:        cpi temp,10
           brne D10
		   ldi dney,32
D10:       cpi temp,11
           brne D11
		   ldi dney,31
D11:       cpi temp,12
           brne D12
		   ldi dney,32
D12:       ret

;***********************************************************
;   
FEVR: 
           mov rez_delim,mlgod
           ldi delitel,4
           sub ostatok,ostatok
		   ldi sch,9
d8u_11:    rol rez_delim
           dec sch
		   brne d8u_21
		   rjmp d8u_41
d8u_21:    rol ostatok
           sub ostatok,delitel
		   brcc d8u_31
		   add ostatok,delitel
		   clc

		   rjmp d8u_11
d8u_31:    sec
           
		   rjmp d8u_11
d8u_41:    tst ostatok
		   brne d8u_4
		   ldi r24,30
		   ret
d8u_4:     ldi r24,29
		   ret
;*************************************************
NAJ0:
           inc naj
		   cpi naj,30
		   breq NAJ01
		   ret
NAJ01:     inc hod
           clr naj
		   mov temp,dinmode
		   cpi temp,0xFF
           breq N0
		   rjmp Hod1
N0:        rjmp Hod0
		   ret


;*************************************************
NAJ1:
           inc naj
		   cpi naj,30
		   breq NAJ11
		   ret
NAJ11:     clr naj
           rjmp UST
		   ret




;*************************************************           
NAJ2:
           inc naj
		   cpi naj,30
		   breq NAJ21
		   ret
NAJ21:     inc hod
           clr naj
		   mov temp,dinmode
		   cpi temp,0xFF
           breq N2
		   rjmp Hod1
N2:        rjmp Hod3
		   ret



;*************************************************
NAJ3:
           inc naj
		   cpi naj,30
		   breq NAJ31
		   ret
NAJ31:     clr naj
           rjmp UST
		   ret

;*************************************************           
NAJ4:
           inc naj
		   cpi naj,30
		   breq NAJ41
		   ret
NAJ41:     inc hod
           clr naj
		   mov temp,dinmode
		   cpi temp,0xFF
           brne N4
		   rjmp Hod4
N4:        rjmp Hod1
		   ret



;*************************************************
NAJ5:
           inc naj
		   cpi naj,30
		   breq NAJ51
		   ret
NAJ51:     clr naj
           rjmp UST
		   ret

;**************************************************
UST:
           cli
		   sbi PORTD,7
		   clr r26
		   clr r27
		   clr sekunda

UST_zl:    
           sbic PIND,1
		   clr r27
		   ldi temp,0b00110000
		   out PORTA,temp
		   cbi PORTD,5
		   rcall ZAD_1_25m
		   sbi PORTD,5

		   ldi temp,0b01001000
		   out PORTA,temp
		   cbi PORTD,4
           rcall ZAD_1_25m
		   sbi PORTD,4

           ldi temp,0b01000000
		   out PORTA,temp
		   cbi PORTC,5
           rcall ZAD_1_25m
		   sbi PORTC,5

		   tst zimleto
		   brne Uzl_2
		   ldi temp,0b00001110
		   out PORTA,temp
		   cbi PORTC,4
           rcall ZAD_1_25m
		   sbi PORTC,4
		   rjmp Uzl_3 
Uzl_2:
           ldi temp,0b00101011
		   out PORTA,temp
		   cbi PORTC,4
           rcall ZAD_1_25m
		   sbi PORTC,4
Uzl_3:
		   sbic PIND,0
		   rjmp UST_zl1
		   inc r26
		   cpi r26,30
		   brne UST_zl1
		   clr r26
		   tst zimleto
		   brne Uzl_1
           inc zimleto
		   rjmp UST_zl1
Uzl_1:     clr zimleto

UST_zl1: 
           sbic PIND,0
		   clr r26
           rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m

		   sbic PIND,1
		   rjmp UST_zl
		   inc r27
		   cpi r27,30
		   brne UST_zl
		   clr r27
           rjmp UST_god

UST_god:   
           sbic PIND,1
		   clr r27
           mov rez_delim,mlgod 
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTC,1
		   rcall ZAD_1_25m
		   sbi PORTC,1

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTC,0
		   rcall ZAD_1_25m
		   sbi PORTC,0
		   

		   mov rez_delim,stgod 
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTC,3
		   rcall ZAD_1_25m
		   sbi PORTC,3

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTC,2
		   rcall ZAD_1_25m
		   sbi PORTC,2

		   sbic PIND,0
		   rjmp UST_god1
		   inc r26
		   cpi r26,30
		   brne UST_god1
		   clr r26
		   inc mlgod
		   inc godzl
		   cpi godzl,28
           brne U1
		   clr godzl
U1:		   mov temp,mlgod
		   cpi temp,100
		   brne UST_god1
		   clr mlgod
		   inc stgod
UST_god1:  
           sbic PIND,0
		   clr r26
           rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m

		   sbic PIND,1
		   rjmp UST_god
		   inc r27
		   cpi r27,30
		   brne UST_god
		   clr r27
           rjmp UST_mes

;*****
UST_mes:   
           sbic PIND,1
		   clr r27
           mov rez_delim,mesyac  ;2
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   cpi r30,0
		   breq HU1
		   cbi PORTC,5
HU1:	   rcall ZAD_1_25m
		   sbi PORTC,5

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTC,4
		   rcall ZAD_1_25m
		   sbi PORTC,4

		   sbic PIND,0
		   rjmp UST_mes1
		   inc r26
		   cpi r26,30
		   brne UST_mes1
		   clr r26
		   inc mesyac
		   mov temp,mesyac
		   cpi temp,13
		   brne UST_mes1
		   clr mesyac
		   inc mesyac
UST_mes1:
           sbic PIND,0
		   clr r26
           rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m

		   sbic PIND,1
		   rjmp UST_mes
		   inc r27
		   cpi r27,30
		   brne UST_mes
		   clr r27
           rjmp UST_den

;*****

UST_den:
           rcall DEN1
		   mov temp,dney
           sub temp,den
		   brpl USD1
		   clr den
		   inc den   
USD1:      brne USD2
           clr den
		   inc den
USD2:            
           sbic PIND,1
		   clr r27
           mov rez_delim,den  ;2
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   cpi r30,0
		   breq HU2
		   cbi PORTD,5
HU2:	   rcall ZAD_1_25m
		   sbi PORTD,5

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTD,4
		   rcall ZAD_1_25m
		   sbi PORTD,4

           sbic PIND,0
		   rjmp UST_den1
		   inc r26 
		   cpi r26,30
		   brne UST_den1
		   clr r26
		   inc den
		   rcall DEN1
		   mov temp,dney
		   sub temp,den
           brmi USD
		   cp den,dney
		   brne UST_den1
USD:	   clr den
		   inc den
UST_den1:  
           sbic PIND,0
		   clr r26
           rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		            

		   sbic PIND,1
		   rjmp UST_den
		   inc r27
		   cpi r27,30
		   brne UST_den
		   clr r27
           rjmp UST_chas

;*****

UST_chas:  cbi PORTD,7
           sbic PIND,1
		   clr r27
           mov rez_delim,chas  ;2
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   cpi r30,0
		   breq HU3
		   cbi PORTC,3
HU3:	   rcall ZAD_1_25m
		   sbi PORTC,3

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTC,2
		   rcall ZAD_1_25m
		   sbi PORTC,2

           sbic PIND,0
		   rjmp UST_chas1
		   inc r26 
		   cpi r26,30
		   brne UST_chas1
		   clr r26
		   inc chas
		   mov temp,chas
		   cpi temp,24
		   brne UST_chas1
		   clr chas
UST_chas1:
           sbic PIND,0
		   clr r26
           rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m

           sbic PIND,1
		   rjmp UST_chas
		   inc r27
		   cpi r27,30
		   brne UST_chas
		   clr r27
           rjmp UST_OPRzl

UST_OPRzl:
           tst zimleto
		   brne OPRzl1
           rjmp UST_min
OPRzl1:     
           mov temp,mesyac
		   cpi temp,11
	       brne OPR12
	       clr zimleto
		   inc zimleto
OPR12:     
           cpi temp,12
	       brne OPR1
	       clr zimleto
		   inc zimleto
OPR1:     
           cpi temp,1
	       brne OPR2
	       clr zimleto
		   inc zimleto
OPR2:      
           cpi temp,2
	       brne OPR4
	       clr zimleto
		   inc zimleto
OPR4:
		   cpi temp,4
	       brne OPR5
	       clr zimleto
		   inc zimleto
		   inc zimleto
OPR5:
		   cpi temp,5
	       brne OPR6
	       clr zimleto
		   inc zimleto
		   inc zimleto
OPR6:
		   cpi temp,6
	       brne OPR7
	       clr zimleto
		   inc zimleto
		   inc zimleto
OPR7:
           cpi temp,7
	       brne OPR8
	       clr zimleto
		   inc zimleto
		   inc zimleto
OPR8:		   
           cpi temp,8
	       brne OPR9
	       clr zimleto
		   inc zimleto
		   inc zimleto
OPR9:
           cpi temp,9
	       brne OPR10
	       clr zimleto
		   inc zimleto
		   inc zimleto
OPR10:
           cpi temp,10
	       brne OPR3
		   rcall DECOKT
		   mov temp,den
		   cp temp,cikldata
           breq OPR10_2
	       brmi OPR10_1
           clr zimleto
		   inc zimleto
		   rjmp OPR3
OPR10_1:       
           clr zimleto
           inc zimleto
           inc zimleto
		   rjmp OPR3
OPR10_2:
           mov temp,chas
		   cpi temp,3
		   brmi OPR10_3
		   clr zimleto
		   inc zimleto
		   rjmp OPR3
OPR10_3:
           clr zimleto
           inc zimleto
           inc zimleto
		   rjmp OPR3



OPR3:      
           mov temp,mesyac
           cpi temp,3
	       brne UST_min
		   rcall DECMAR
		   mov temp,den
		   cp temp,cikldata
           breq OPR3_2
	       brmi OPR3_1
           clr zimleto
		   inc zimleto
		   inc zimleto
		   rjmp UST_min
OPR3_1:       
           clr zimleto
           inc zimleto
		   rjmp UST_min
OPR3_2:
           mov temp,chas
		   cpi temp,2
		   brmi OPR3_3
		   clr zimleto
		   inc zimleto
		   inc zimleto
		   rjmp UST_min
OPR3_3:
           clr zimleto
           inc zimleto
		   rjmp UST_min

;*****

UST_min:   cbi PORTD,7
           sbic PIND,1
		   clr r27
           mov rez_delim,minuta  ;2
		   rcall del_na_10
		   mov r30,rez_delim
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTC,1
		   rcall ZAD_1_25m
		   sbi PORTC,1

		   mov r30,ostatok
		   rcall DECOD
		   out PORTA,temp
		   cbi PORTC,0
		   rcall ZAD_1_25m
		   sbi PORTC,0

           sbic PIND,0
		   rjmp UST_min1
		   inc r26 
		   cpi r26,30
		   brne UST_min1
		   clr r26
		   inc minuta
		   mov temp,minuta
		   cpi temp,60
		   brne UST_min1
		   clr minuta
UST_min1:
           sbic PIND,0
		   clr r26
           rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
		   rcall ZAD_1_25m
          
		   sbic PIND,1
		   rjmp UST_min
		   inc r27
		   cpi r27,30
		   brne UST_min
		   clr r27
           ldi temp,0xFF
		   mov dinmode,temp
           rjmp VIXOD

VIXOD:     rjmp Hod10
		   ret           
;**************************************************
DECOD:
       cpi r30,0
	   brne DE1
	   ldi temp,dig0
DE1:   cpi r30,1
       brne DE2
	   ldi temp,dig1
DE2:   cpi r30,2
       brne DE3
	   ldi temp,dig2
DE3:   cpi r30,3
       brne DE4
	   ldi temp,dig3
DE4:   cpi r30,4
       brne DE5
	   ldi temp,dig4
DE5:   cpi r30,5
       brne DE6
	   ldi temp,dig5
DE6:   cpi r30,6
       brne DE7
	   ldi temp,dig6
DE7:   cpi r30,7
       brne DE8
	   ldi temp,dig7
DE8:   cpi r30,8
       brne DE9
	   ldi temp,dig8
DE9:   cpi r30,9
       brne DE10
	   ldi temp,dig9
DE10:  ret
;**************************************************
;**************************************************
;**************************************************
; 
;****  10****
ZAD_10mks:       	 
              ldi r28,0x0B
MZ10:         dec r28
              brne MZ10
		      ret

;**************************************************
;****  12.5****

ZAD_12_5mks:       	 
              ldi r28,0x0E
MZ12:         dec r28
              brne MZ12
		      nop
		      ret

;**************************************************
;****  20****

ZAD_20mks:       	 
               ldi r28,0x18
MZ20:          dec r28
               brne MZ20
		       nop
		       ret

;**************************************************
;****  45****

ZAD_45mks:       	 
               ldi r28,0x39
MZ45:          dec r28
               brne MZ45
		       nop
		       nop
		       ret

;**************************************************
;****  60****

ZAD_60mks:       	 
               ldi r28,0x4D
MZ60:          dec r28
               brne MZ60
		       nop
		       nop
		       ret
;**************************************************
;****  70****

ZAD_70mks:       	 
                ldi r28,0x5B
MZ70:           dec r28
                brne MZ70
		ret

;**************************************************
;****  320****

ZAD_320mks:       	 
                ldi r29,0x02
		ldi r28,0xA6
MZ320:          dec r28
                brne MZ320
		dec r29
		brne MZ320
		nop
		nop
		ret

;**************************************************
;****  338****

ZAD_338mks:       	 
        ldi r29,0x02
		ldi r28,0xBE
MZ338:  dec r28
        brne MZ338
		dec r29
		brne MZ338
		nop
		nop
		ret

;**************************************************
;****  380****

ZAD_380mks:       	 
        ldi r29,0x02
		ldi r28,0xF6
MZ380:  dec r28
        brne MZ380
		dec r29
		brne MZ380
		nop
		nop
		ret

;**************************************************
;****  1760****

ZAD_1760mks:       	 
        ldi r29,0x0A
		ldi r28,0x21
MZ1760: dec r28
        brne MZ1760
		dec r29
		brne MZ1760
		nop
		ret

;**************************************************
;****  480****

ZAD_480mks:       	 
                ldi r29,0x03
		ldi r28,0x7B
MZ480:          dec r28
                brne MZ480
		dec r29
		brne MZ480
		nop
		ret

;**************************************************

ABCT: ldi temp,0x01
      mov temperznak,temp
	  ret

;**************************************************
;     (
; 28 )(   2000
;,   2027,    
; 0  27).
;**************************************************

DECOKT:
       cpi godzl,0
	   brne DOK1
	   ldi temp,29
	   mov cikldata,temp
DOK1:  cpi godzl,1
	   brne DOK2
	   ldi temp,28
	   mov cikldata,temp
DOK2:  cpi godzl,2
	   brne DOK3
	   ldi temp,27
	   mov cikldata,temp
DOK3:  cpi godzl,3
	   brne DOK4
	   ldi temp,26
	   mov cikldata,temp
DOK4:  cpi godzl,4
	   brne DOK5
	   ldi temp,31
	   mov cikldata,temp
DOK5:  cpi godzl,5
	   brne DOK6
	   ldi temp,30
	   mov cikldata,temp
DOK6:  cpi godzl,6
	   brne DOK7
	   ldi temp,29
	   mov cikldata,temp
DOK7:  cpi godzl,7
	   brne DOK8
	   ldi temp,28
	   mov cikldata,temp
DOK8:  cpi godzl,8
	   brne DOK9
	   ldi temp,26
	   mov cikldata,temp
DOK9:  cpi godzl,9
	   brne DOK10
	   ldi temp,25
	   mov cikldata,temp
DOK10: cpi godzl,10
	   brne DOK11
	   ldi temp,31
	   mov cikldata,temp
DOK11: cpi godzl,11
	   brne DOK12
	   ldi temp,30
	   mov cikldata,temp
DOK12: cpi godzl,12
	   brne DOK13
	   ldi temp,28
	   mov cikldata,temp
DOK13: cpi godzl,13
	   brne DOK14
	   ldi temp,27
	   mov cikldata,temp
DOK14: cpi godzl,14
	   brne DOK15
	   ldi temp,26
	   mov cikldata,temp
DOK15: cpi godzl,15
	   brne DOK16
	   ldi temp,25
	   mov cikldata,temp
DOK16: cpi godzl,16
	   brne DOK17
	   ldi temp,30
	   mov cikldata,temp
DOK17: cpi godzl,17
	   brne DOK18
	   ldi temp,29
	   mov cikldata,temp
DOK18: cpi godzl,18
	   brne DOK19
	   ldi temp,28
	   mov cikldata,temp
DOK19: cpi godzl,19
	   brne DOK20
	   ldi temp,27
	   mov cikldata,temp
DOK20: cpi godzl,20
	   brne DOK21
	   ldi temp,25
	   mov cikldata,temp
DOK21: cpi godzl,21
	   brne DOK22
	   ldi temp,31
	   mov cikldata,temp
DOK22: cpi godzl,22
	   brne DOK23
	   ldi temp,30
	   mov cikldata,temp
DOK23: cpi godzl,23
	   brne DOK24
	   ldi temp,29
	   mov cikldata,temp
DOK24: cpi godzl,24
	   brne DOK25
	   ldi temp,27
	   mov cikldata,temp
DOK25: cpi godzl,25
	   brne DOK26
	   ldi temp,26
	   mov cikldata,temp
DOK26: cpi godzl,26
	   brne DOK27
	   ldi temp,25
	   mov cikldata,temp
DOK27: cpi godzl,27
	   brne DOK28
	   ldi temp,31
	   mov cikldata,temp
DOK28: ret
;**************************************************
;     (
; 28 )(   2000
;,   2027,    
; 0  27).
;**************************************************

DECMAR:
       cpi godzl,0
	   brne DM1
	   ldi temp,26
	   mov cikldata,temp
DM1:   cpi godzl,1
	   brne DM2
	   ldi temp,25
	   mov cikldata,temp
DM2:   cpi godzl,2
	   brne DM3
	   ldi temp,31
	   mov cikldata,temp
DM3:   cpi godzl,3
	   brne DM4
	   ldi temp,30
	   mov cikldata,temp
DM4:   cpi godzl,4
	   brne DM5
	   ldi temp,28
	   mov cikldata,temp
DM5:   cpi godzl,5
	   brne DM6
	   ldi temp,27
	   mov cikldata,temp
DM6:   cpi godzl,6
	   brne DM7
	   ldi temp,26
	   mov cikldata,temp
DM7:   cpi godzl,7
	   brne DM8
	   ldi temp,25
	   mov cikldata,temp
DM8:   cpi godzl,8
	   brne DM9
	   ldi temp,30
	   mov cikldata,temp
DM9:   cpi godzl,9
	   brne DM10
	   ldi temp,29
	   mov cikldata,temp
DM10:  cpi godzl,10
	   brne DM11
	   ldi temp,28
	   mov cikldata,temp
DM11:  cpi godzl,11
	   brne DM12
	   ldi temp,27
	   mov cikldata,temp
DM12:  cpi godzl,12
	   brne DM13
	   ldi temp,25
	   mov cikldata,temp
DM13:  cpi godzl,13
	   brne DM14
	   ldi temp,31
	   mov cikldata,temp
DM14:  cpi godzl,14
	   brne DM15
	   ldi temp,30
	   mov cikldata,temp
DM15:  cpi godzl,15
	   brne DM16
	   ldi temp,29
	   mov cikldata,temp
DM16:  cpi godzl,16
	   brne DM17
	   ldi temp,27
	   mov cikldata,temp
DM17:  cpi godzl,17
	   brne DM18
	   ldi temp,26
	   mov cikldata,temp
DM18:  cpi godzl,18
	   brne DM19
	   ldi temp,25
	   mov cikldata,temp
DM19:  cpi godzl,19
	   brne DM20
	   ldi temp,31
	   mov cikldata,temp
DM20:  cpi godzl,20
	   brne DM21
	   ldi temp,29
	   mov cikldata,temp
DM21:  cpi godzl,21
	   brne DM22
	   ldi temp,28
	   mov cikldata,temp
DM22:  cpi godzl,22
	   brne DM23
	   ldi temp,27
	   mov cikldata,temp
DM23:  cpi godzl,23
	   brne DM24
	   ldi temp,26
	   mov cikldata,temp
DM24:  cpi godzl,24
	   brne DM25
	   ldi temp,31
	   mov cikldata,temp
DM25:  cpi godzl,25
	   brne DM26
	   ldi temp,30
	   mov cikldata,temp
DM26:  cpi godzl,26
	   brne DM27
	   ldi temp,29
	   mov cikldata,temp
DM27:  cpi godzl,27
	   brne DM28
	   ldi temp,28
	   mov cikldata,temp
DM28:  ret
;**************************************************************
;**************************************************************
;**************************************************************
ZLVREMYA:
       
	   tst zimleto
	   brne ZLV
	   rjmp VIX
ZLV:   mov temp,zimleto
       cpi temp,1
	   breq MAR
	   rjmp OKT
MAR:
       mov temp,mesyac
	   cpi temp,3
	   brne VIX
	   rcall DECMAR
	   cpse cikldata,den
	   rjmp VIX
	   mov temp,chas
	   cpi temp,2
	   brne VIX
	   ldi temp,3
	   mov chas,temp
	   ldi temp,2
	   mov zimleto,temp
	   rjmp VIX
	   
OKT:   
       mov temp,mesyac
	   cpi temp,10
	   brne VIX
	   rcall DECOKT
	   cpse cikldata,den
	   rjmp VIX
	   mov temp,chas
	   cpi temp,3
	   brne VIX
	   ldi temp,2
	   mov chas,temp
	   ldi temp,1
	   mov zimleto,temp
VIX:   ret
